# community.docker.docker_plugin module – Manage Docker plugins — Community.Docker Collection documentation

# community.docker.docker_plugin module – Manage Docker plugins

Note

This module is part of the community.docker collection (version 3.4.3).

To install it, use: `ansible-galaxy collection install community.docker`. You need further requirements to be able to use this module, see Requirements for details.

To use it in a playbook, specify: `community.docker.docker_plugin`.

New in community.docker 1.3.0

## Synopsis

- This module allows to install, delete, enable and disable Docker plugins.

- Performs largely the same function as the `docker plugin` CLI subcommand.

## Requirements

The below requirements are needed on the host that executes this module.

- Docker API >= 1.25

- backports.ssl_match_hostname (when using TLS on Python 2)

- paramiko (when using SSH with use_ssh_client=false)

- pyOpenSSL (when using TLS)

- pywin32 (when using named pipes on Windows 32)

- requests

## Parameters

Parameter | Comments
--- | ---
alias string added in community.docker 1.8.0 | Local name for plugin.

api_version

aliases: docker_api_version

string

The version of the Docker API running on the Docker Host.

Defaults to the latest version of the API supported by this collection and the docker daemon.

If the value is not specified in the task, the value of environment variable `DOCKER_API_VERSION` will be used instead. If the environment variable is not set, the default value will be used.

Default: `"auto"`

ca_cert aliases: tls_ca_cert, cacert_path path | Use a CA certificate when performing server verification by providing the path to a CA certificate file. If the value is not specified in the task and the environment variable `DOCKER_CERT_PATH` is set, the file `ca.pem` from the directory specified in the environment variable `DOCKER_CERT_PATH` will be used.
client_cert aliases: tls_client_cert, cert_path path | Path to the client’s TLS certificate file. If the value is not specified in the task and the environment variable `DOCKER_CERT_PATH` is set, the file `cert.pem` from the directory specified in the environment variable `DOCKER_CERT_PATH` will be used.
client_key aliases: tls_client_key, key_path path | Path to the client’s TLS key file. If the value is not specified in the task and the environment variable `DOCKER_CERT_PATH` is set, the file `key.pem` from the directory specified in the environment variable `DOCKER_CERT_PATH` will be used.

debug

boolean

Debug mode

Choices:

- `false` ← (default)

- `true`

docker_host

aliases: docker_url

string

The URL or Unix socket path used to connect to the Docker API. To connect to a remote host, provide the TCP connection string. For example, `tcp://192.0.2.23:2376`. If TLS is used to encrypt the connection, the module will automatically replace `tcp` in the connection URL with `https`.

If the value is not specified in the task, the value of environment variable `DOCKER_HOST` will be used instead. If the environment variable is not set, the default value will be used.

Default: `"unix://var/run/docker.sock"`

enable_timeout integer | Timeout in seconds. Default: `0`

force_remove

boolean

Remove even if the plugin is enabled.

Choices:

- `false` ← (default)

- `true`

plugin_name string / required | Name of the plugin to operate on.
plugin_options dictionary | Dictionary of plugin settings. Default: `{}`
ssl_version string | Provide a valid SSL version number. Default value determined by ssl.py module. If the value is not specified in the task, the value of environment variable `DOCKER_SSL_VERSION` will be used instead.

state

string

`absent` remove the plugin.

`present` install the plugin, if it does not already exist.

`enable` enable the plugin.

`disable` disable the plugin.

Choices:

- `"absent"`

- `"present"` ← (default)

- `"enable"`

- `"disable"`

timeout integer | The maximum amount of time in seconds to wait on a response from the API. If the value is not specified in the task, the value of environment variable `DOCKER_TIMEOUT` will be used instead. If the environment variable is not set, the default value will be used. Default: `60`

tls

boolean

Secure the connection to the API by using TLS without verifying the authenticity of the Docker host server. Note that if validate_certs is set to `true` as well, it will take precedence.

If the value is not specified in the task, the value of environment variable `DOCKER_TLS` will be used instead. If the environment variable is not set, the default value will be used.

Choices:

- `false` ← (default)

- `true`

tls_hostname

string

When verifying the authenticity of the Docker Host server, provide the expected name of the server.

If the value is not specified in the task, the value of environment variable `DOCKER_TLS_HOSTNAME` will be used instead. If the environment variable is not set, the default value will be used.

Note that this option had a default value `localhost` in older versions. It was removed in community.docker 3.0.0.

use_ssh_client

boolean

added in community.docker 1.5.0

For SSH transports, use the `ssh` CLI tool instead of paramiko.

Choices:

- `false` ← (default)

- `true`

validate_certs

aliases: tls_verify

boolean

Secure the connection to the API by using TLS and verifying the authenticity of the Docker host server.

If the value is not specified in the task, the value of environment variable `DOCKER_TLS_VERIFY` will be used instead. If the environment variable is not set, the default value will be used.

Choices:

- `false` ← (default)

- `true`

## Attributes

Attribute | Support | Description
--- | --- | ---
action_group | Action groups: community.docker.docker, docker | Use `group/docker` or `group/community.docker.docker` in `module_defaults` to set defaults for this module.
check_mode | Support: full | Can run in `check_mode` and return changed status prediction without modifying target.
diff_mode | Support: full | Will return details on what has changed (or possibly needs changing in `check_mode`), when in diff mode.

## Notes

Note

- Connect to the Docker daemon by providing parameters with each task or by defining environment variables. You can define `DOCKER_HOST`, `DOCKER_TLS_HOSTNAME`, `DOCKER_API_VERSION`, `DOCKER_CERT_PATH`, `DOCKER_SSL_VERSION`, `DOCKER_TLS`, `DOCKER_TLS_VERIFY` and `DOCKER_TIMEOUT`. If you are using docker machine, run the script shipped with the product that sets up the environment. It will set these variables for you. See https://docs.docker.com/machine/reference/env/ for more details.

- This module does not use the Docker SDK for Python to communicate with the Docker daemon. It uses code derived from the Docker SDK or Python that is included in this collection.

## Examples

    - name: Install a plugin
      community.docker.docker_plugin:
        plugin_name: plugin_one
        state: present

    - name: Remove a plugin
      community.docker.docker_plugin:
        plugin_name: plugin_one
        state: absent

    - name: Enable the plugin
      community.docker.docker_plugin:
        plugin_name: plugin_one
        state: enable

    - name: Disable the plugin
      community.docker.docker_plugin:
        plugin_name: plugin_one
        state: disable

    - name: Install a plugin with options
      community.docker.docker_plugin:
        plugin_name: weaveworks/net-plugin:latest_release
        plugin_options:
          IPALLOC_RANGE: "10.32.0.0/12"
          WEAVE_PASSWORD: "PASSWORD"

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Description
--- | ---
actions list / elements=string | List of actions performed during task execution. Returned: when state!=absent
plugin dictionary | Plugin inspection results for the affected plugin. Returned: success Sample: `{}`

### Authors

- Sakar Mehra (@sakar97)

- Vladimir Porshkevich (@porshkevich)

### Collection links

Issue Tracker Repository (Sources) Submit a bug report Request a feature Communication